/// <reference path="./custom.d.ts" />
// tslint:disable
// @ts-nocheck
/**
 * OCM Gateway
 * OCM ENGINE GATEWAY API
 *
 * OpenAPI spec version: 1.0
 *
 *
 * NOTE: This file is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the file manually.
 */

import * as url from "url";
import * as isomorphicFetch from "isomorphic-fetch";
import { Configuration } from "./configuration";

const BASE_PATH = "http://0.0.0.0:8081".replace(/\/+$/, "");

/**
 *
 * @export
 */
export const COLLECTION_FORMATS = {
    csv: ",",
    ssv: " ",
    tsv: "\t",
    pipes: "|",
};

/**
 *
 * @export
 * @interface FetchAPI
 */
export interface FetchAPI {
    (url: string, init?: any): Promise<Response>;
}

/**
 *
 * @export
 * @interface FetchArgs
 */
export interface FetchArgs {
    url: string;
    options: any;
}

/**
 *
 * @export
 * @class BaseAPI
 */
export class BaseAPI {
    protected configuration: Configuration;

    constructor(configuration?: Configuration, protected basePath: string = BASE_PATH, protected fetch: FetchAPI = isomorphicFetch) {
        if (configuration) {
            this.configuration = configuration;
            this.basePath = configuration.basePath || this.basePath;
        }
    }
};

/**
 *
 * @export
 * @class RequiredError
 * @extends {Error}
 */
export class RequiredError extends Error {
    name: "RequiredError"
    constructor(public field: string, msg?: string) {
        super(msg);
    }
}

/**
 *
 * @export
 * @interface CloudEventDto
 */
export interface CloudEventDto {
}
/**
 *
 * @export
 * @interface CreateCredentialDefinitionRequsetDto
 */
export interface CreateCredentialDefinitionRequsetDto {
    /**
     *
     * @type {string}
     * @memberof CreateCredentialDefinitionRequsetDto
     */
    schemaId: string;
    /**
     *
     * @type {string}
     * @memberof CreateCredentialDefinitionRequsetDto
     */
    tag: string;
}
/**
 *
 * @export
 * @interface CreateInvitationResponseDto
 */
export interface CreateInvitationResponseDto {
    /**
     * A list of user's roles
     * @type {string}
     * @memberof CreateInvitationResponseDto
     */
    invitationUrl: string;
}
/**
 *
 * @export
 * @interface CreateSchemaRequestDto
 */
export interface CreateSchemaRequestDto {
    /**
     *
     * @type {string}
     * @memberof CreateSchemaRequestDto
     */
    name: string;
    /**
     *
     * @type {Array<string>}
     * @memberof CreateSchemaRequestDto
     */
    attributes: Array<string>;
    /**
     *
     * @type {string}
     * @memberof CreateSchemaRequestDto
     */
    version: string;
}
/**
 *
 * @export
 * @interface GatewayAcceptedResponseDto
 */
export interface GatewayAcceptedResponseDto {
    /**
     *
     * @type {string}
     * @memberof GatewayAcceptedResponseDto
     */
    id: string;
}
/**
 *
 * @export
 * @interface GetSchemaRequestDto
 */
export interface GetSchemaRequestDto {
    /**
     *
     * @type {string}
     * @memberof GetSchemaRequestDto
     */
    schemaId: string;
}
/**
 *
 * @export
 * @interface InlineResponse400
 */
export interface InlineResponse400 {
    /**
     *
     * @type {number}
     * @memberof InlineResponse400
     */
    statusCode?: number;
    /**
     *
     * @type {Array}
     * @memberof InlineResponse400
     */
    message?: Array;
    /**
     *
     * @type {string}
     * @memberof InlineResponse400
     */
    error?: string;
}
/**
 *
 * @export
 * @interface InlineResponse4001
 */
export interface InlineResponse4001 {
    /**
     *
     * @type {number}
     * @memberof InlineResponse4001
     */
    statusCode?: number;
    /**
     *
     * @type {Array}
     * @memberof InlineResponse4001
     */
    message?: Array;
    /**
     *
     * @type {string}
     * @memberof InlineResponse4001
     */
    error?: string;
}
/**
 *
 * @export
 * @interface InlineResponse4002
 */
export interface InlineResponse4002 {
    /**
     *
     * @type {number}
     * @memberof InlineResponse4002
     */
    statusCode?: number;
    /**
     *
     * @type {Array}
     * @memberof InlineResponse4002
     */
    message?: Array;
    /**
     *
     * @type {string}
     * @memberof InlineResponse4002
     */
    error?: string;
}
/**
 *
 * @export
 * @interface InlineResponse4003
 */
export interface InlineResponse4003 {
    /**
     *
     * @type {number}
     * @memberof InlineResponse4003
     */
    statusCode?: number;
    /**
     *
     * @type {Array}
     * @memberof InlineResponse4003
     */
    message?: Array;
    /**
     *
     * @type {string}
     * @memberof InlineResponse4003
     */
    error?: string;
}
/**
 *
 * @export
 * @interface InlineResponse4004
 */
export interface InlineResponse4004 {
    /**
     *
     * @type {number}
     * @memberof InlineResponse4004
     */
    statusCode?: number;
    /**
     *
     * @type {Array}
     * @memberof InlineResponse4004
     */
    message?: Array;
    /**
     *
     * @type {string}
     * @memberof InlineResponse4004
     */
    error?: string;
}
/**
 *
 * @export
 * @interface InlineResponse4005
 */
export interface InlineResponse4005 {
    /**
     *
     * @type {number}
     * @memberof InlineResponse4005
     */
    statusCode?: number;
    /**
     *
     * @type {Array}
     * @memberof InlineResponse4005
     */
    message?: Array;
    /**
     *
     * @type {string}
     * @memberof InlineResponse4005
     */
    error?: string;
}
/**
 *
 * @export
 * @interface InlineResponse4006
 */
export interface InlineResponse4006 {
    /**
     *
     * @type {number}
     * @memberof InlineResponse4006
     */
    statusCode?: number;
    /**
     *
     * @type {Array}
     * @memberof InlineResponse4006
     */
    message?: Array;
    /**
     *
     * @type {string}
     * @memberof InlineResponse4006
     */
    error?: string;
}
/**
 *
 * @export
 * @interface InlineResponse500
 */
export interface InlineResponse500 {
    /**
     *
     * @type {number}
     * @memberof InlineResponse500
     */
    statusCode?: number;
    /**
     *
     * @type {string}
     * @memberof InlineResponse500
     */
    message?: string;
}
/**
 *
 * @export
 * @interface InlineResponse5001
 */
export interface InlineResponse5001 {
    /**
     *
     * @type {number}
     * @memberof InlineResponse5001
     */
    statusCode?: number;
    /**
     *
     * @type {string}
     * @memberof InlineResponse5001
     */
    message?: string;
}
/**
 *
 * @export
 * @interface InlineResponse5002
 */
export interface InlineResponse5002 {
    /**
     *
     * @type {number}
     * @memberof InlineResponse5002
     */
    statusCode?: number;
    /**
     *
     * @type {string}
     * @memberof InlineResponse5002
     */
    message?: string;
}
/**
 *
 * @export
 * @interface IssueCredentialAttributes
 */
export interface IssueCredentialAttributes {
    /**
     *
     * @type {string}
     * @memberof IssueCredentialAttributes
     */
    name: string;
    /**
     *
     * @type {string}
     * @memberof IssueCredentialAttributes
     */
    value: string;
}
/**
 *
 * @export
 * @interface IssueCredentialRequestDto
 */
export interface IssueCredentialRequestDto {
    /**
     *
     * @type {string}
     * @memberof IssueCredentialRequestDto
     */
    connectionId: string;
    /**
     *
     * @type {string}
     * @memberof IssueCredentialRequestDto
     */
    credentialDefinitionId: string;
    /**
     *
     * @type {Array<IssueCredentialAttributes>}
     * @memberof IssueCredentialRequestDto
     */
    attributes: Array<IssueCredentialAttributes>;
}
/**
 *
 * @export
 * @interface IssueProofAttribute
 */
export interface IssueProofAttribute {
    /**
     *
     * @type {string}
     * @memberof IssueProofAttribute
     */
    attributeName: string;
    /**
     *
     * @type {string}
     * @memberof IssueProofAttribute
     */
    credentialDefinitionId: string;
    /**
     *
     * @type {string}
     * @memberof IssueProofAttribute
     */
    schemaId: string;
}
/**
 *
 * @export
 * @interface IssueProofRequestDto
 */
export interface IssueProofRequestDto {
    /**
     *
     * @type {string}
     * @memberof IssueProofRequestDto
     */
    connectionId?: string;
    /**
     *
     * @type {Array<IssueProofAttribute>}
     * @memberof IssueProofRequestDto
     */
    attributes: Array<IssueProofAttribute>;
}
/**
 *
 * @export
 * @interface MakeBasicMessageRequestDto
 */
export interface MakeBasicMessageRequestDto {
    /**
     *
     * @type {string}
     * @memberof MakeBasicMessageRequestDto
     */
    connectionId: string;
    /**
     *
     * @type {string}
     * @memberof MakeBasicMessageRequestDto
     */
    message: string;
}
/**
 * ConnectionsApi - fetch parameter creator
 * @export
 */
export const ConnectionsApiFetchParamCreator = function (configuration?: Configuration) {
    return {
        /**
         * Method will accept the invitation and will return connection thought the websocket. The id of the response will be matched when you receive event from the websocket
         * @summary Accept invitation for connection
         * @param {CreateInvitationResponseDto} body
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        connectionControllerAcceptInvitation(body: CreateInvitationResponseDto, options: any = {}): FetchArgs {
            // verify required parameter 'body' is not null or undefined
            if (body === null || body === undefined) {
                throw new RequiredError('body','Required parameter body was null or undefined when calling connectionControllerAcceptInvitation.');
            }
            const localVarPath = `/api/v1/invitations/accept`;
            const localVarUrlObj = url.parse(localVarPath, true);
            const localVarRequestOptions = Object.assign({ method: 'POST' }, options);
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            localVarHeaderParameter['Content-Type'] = 'application/json';

            localVarUrlObj.query = Object.assign({}, localVarUrlObj.query, localVarQueryParameter, options.query);
            // fix override query string Detail: https://stackoverflow.com/a/7517673/1077943
            delete localVarUrlObj.search;
            localVarRequestOptions.headers = Object.assign({}, localVarHeaderParameter, options.headers);
            const needsSerialization = (<any>"CreateInvitationResponseDto" !== "string") || localVarRequestOptions.headers['Content-Type'] === 'application/json';
            localVarRequestOptions.body =  needsSerialization ? JSON.stringify(body || {}) : (body || "");

            return {
                url: url.format(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * Method will create invitation url. The id of the response will be matched when you receive event from the websocket
         * @summary Create invitation for connection
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        connectionControllerCreateInvitation(options: any = {}): FetchArgs {
            const localVarPath = `/api/v1/invitations`;
            const localVarUrlObj = url.parse(localVarPath, true);
            const localVarRequestOptions = Object.assign({ method: 'POST' }, options);
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            localVarUrlObj.query = Object.assign({}, localVarUrlObj.query, localVarQueryParameter, options.query);
            // fix override query string Detail: https://stackoverflow.com/a/7517673/1077943
            delete localVarUrlObj.search;
            localVarRequestOptions.headers = Object.assign({}, localVarHeaderParameter, options.headers);

            return {
                url: url.format(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * The method will search for connection id, if not found null will be returned. The id of the response will be matched when you receive event from the websocket
         * @summary Get connection by id
         * @param {string} id
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        connectionControllerGetById(id: string, options: any = {}): FetchArgs {
            // verify required parameter 'id' is not null or undefined
            if (id === null || id === undefined) {
                throw new RequiredError('id','Required parameter id was null or undefined when calling connectionControllerGetById.');
            }
            const localVarPath = `/api/v1/connections/{id}`
                .replace(`{${"id"}}`, encodeURIComponent(String(id)));
            const localVarUrlObj = url.parse(localVarPath, true);
            const localVarRequestOptions = Object.assign({ method: 'GET' }, options);
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            localVarUrlObj.query = Object.assign({}, localVarUrlObj.query, localVarQueryParameter, options.query);
            // fix override query string Detail: https://stackoverflow.com/a/7517673/1077943
            delete localVarUrlObj.search;
            localVarRequestOptions.headers = Object.assign({}, localVarHeaderParameter, options.headers);

            return {
                url: url.format(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * The id of the response will be matched when you receive event from the websocket
         * @summary List all connections
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        connectionControllerList(options: any = {}): FetchArgs {
            const localVarPath = `/api/v1/connections`;
            const localVarUrlObj = url.parse(localVarPath, true);
            const localVarRequestOptions = Object.assign({ method: 'GET' }, options);
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            localVarUrlObj.query = Object.assign({}, localVarUrlObj.query, localVarQueryParameter, options.query);
            // fix override query string Detail: https://stackoverflow.com/a/7517673/1077943
            delete localVarUrlObj.search;
            localVarRequestOptions.headers = Object.assign({}, localVarHeaderParameter, options.headers);

            return {
                url: url.format(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
    }
};

/**
 * ConnectionsApi - functional programming interface
 * @export
 */
export const ConnectionsApiFp = function(configuration?: Configuration) {
    return {
        /**
         * Method will accept the invitation and will return connection thought the websocket. The id of the response will be matched when you receive event from the websocket
         * @summary Accept invitation for connection
         * @param {CreateInvitationResponseDto} body
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        connectionControllerAcceptInvitation(body: CreateInvitationResponseDto, options?: any): (fetch?: FetchAPI, basePath?: string) => Promise<GatewayAcceptedResponseDto> {
            const localVarFetchArgs = ConnectionsApiFetchParamCreator(configuration).connectionControllerAcceptInvitation(body, options);
            return (fetch: FetchAPI = isomorphicFetch, basePath: string = BASE_PATH) => {
                return fetch(basePath + localVarFetchArgs.url, localVarFetchArgs.options).then((response) => {
                    if (response.status >= 200 && response.status < 300) {
                        return response.json();
                    } else {
                        throw response;
                    }
                });
            };
        },
        /**
         * Method will create invitation url. The id of the response will be matched when you receive event from the websocket
         * @summary Create invitation for connection
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        connectionControllerCreateInvitation(options?: any): (fetch?: FetchAPI, basePath?: string) => Promise<GatewayAcceptedResponseDto> {
            const localVarFetchArgs = ConnectionsApiFetchParamCreator(configuration).connectionControllerCreateInvitation(options);
            return (fetch: FetchAPI = isomorphicFetch, basePath: string = BASE_PATH) => {
                return fetch(basePath + localVarFetchArgs.url, localVarFetchArgs.options).then((response) => {
                    if (response.status >= 200 && response.status < 300) {
                        return response.json();
                    } else {
                        throw response;
                    }
                });
            };
        },
        /**
         * The method will search for connection id, if not found null will be returned. The id of the response will be matched when you receive event from the websocket
         * @summary Get connection by id
         * @param {string} id
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        connectionControllerGetById(id: string, options?: any): (fetch?: FetchAPI, basePath?: string) => Promise<GatewayAcceptedResponseDto> {
            const localVarFetchArgs = ConnectionsApiFetchParamCreator(configuration).connectionControllerGetById(id, options);
            return (fetch: FetchAPI = isomorphicFetch, basePath: string = BASE_PATH) => {
                return fetch(basePath + localVarFetchArgs.url, localVarFetchArgs.options).then((response) => {
                    if (response.status >= 200 && response.status < 300) {
                        return response.json();
                    } else {
                        throw response;
                    }
                });
            };
        },
        /**
         * The id of the response will be matched when you receive event from the websocket
         * @summary List all connections
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        connectionControllerList(options?: any): (fetch?: FetchAPI, basePath?: string) => Promise<GatewayAcceptedResponseDto> {
            const localVarFetchArgs = ConnectionsApiFetchParamCreator(configuration).connectionControllerList(options);
            return (fetch: FetchAPI = isomorphicFetch, basePath: string = BASE_PATH) => {
                return fetch(basePath + localVarFetchArgs.url, localVarFetchArgs.options).then((response) => {
                    if (response.status >= 200 && response.status < 300) {
                        return response.json();
                    } else {
                        throw response;
                    }
                });
            };
        },
    }
};

/**
 * ConnectionsApi - factory interface
 * @export
 */
export const ConnectionsApiFactory = function (configuration?: Configuration, fetch?: FetchAPI, basePath?: string) {
    return {
        /**
         * Method will accept the invitation and will return connection thought the websocket. The id of the response will be matched when you receive event from the websocket
         * @summary Accept invitation for connection
         * @param {CreateInvitationResponseDto} body
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        connectionControllerAcceptInvitation(body: CreateInvitationResponseDto, options?: any) {
            return ConnectionsApiFp(configuration).connectionControllerAcceptInvitation(body, options)(fetch, basePath);
        },
        /**
         * Method will create invitation url. The id of the response will be matched when you receive event from the websocket
         * @summary Create invitation for connection
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        connectionControllerCreateInvitation(options?: any) {
            return ConnectionsApiFp(configuration).connectionControllerCreateInvitation(options)(fetch, basePath);
        },
        /**
         * The method will search for connection id, if not found null will be returned. The id of the response will be matched when you receive event from the websocket
         * @summary Get connection by id
         * @param {string} id
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        connectionControllerGetById(id: string, options?: any) {
            return ConnectionsApiFp(configuration).connectionControllerGetById(id, options)(fetch, basePath);
        },
        /**
         * The id of the response will be matched when you receive event from the websocket
         * @summary List all connections
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        connectionControllerList(options?: any) {
            return ConnectionsApiFp(configuration).connectionControllerList(options)(fetch, basePath);
        },
    };
};

/**
 * ConnectionsApi - object-oriented interface
 * @export
 * @class ConnectionsApi
 * @extends {BaseAPI}
 */
export class ConnectionsApi extends BaseAPI {
    /**
     * Method will accept the invitation and will return connection thought the websocket. The id of the response will be matched when you receive event from the websocket
     * @summary Accept invitation for connection
     * @param {CreateInvitationResponseDto} body
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof ConnectionsApi
     */
    public connectionControllerAcceptInvitation(body: CreateInvitationResponseDto, options?: any) {
        return ConnectionsApiFp(this.configuration).connectionControllerAcceptInvitation(body, options)(this.fetch, this.basePath);
    }

    /**
     * Method will create invitation url. The id of the response will be matched when you receive event from the websocket
     * @summary Create invitation for connection
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof ConnectionsApi
     */
    public connectionControllerCreateInvitation(options?: any) {
        return ConnectionsApiFp(this.configuration).connectionControllerCreateInvitation(options)(this.fetch, this.basePath);
    }

    /**
     * The method will search for connection id, if not found null will be returned. The id of the response will be matched when you receive event from the websocket
     * @summary Get connection by id
     * @param {string} id
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof ConnectionsApi
     */
    public connectionControllerGetById(id: string, options?: any) {
        return ConnectionsApiFp(this.configuration).connectionControllerGetById(id, options)(this.fetch, this.basePath);
    }

    /**
     * The id of the response will be matched when you receive event from the websocket
     * @summary List all connections
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof ConnectionsApi
     */
    public connectionControllerList(options?: any) {
        return ConnectionsApiFp(this.configuration).connectionControllerList(options)(this.fetch, this.basePath);
    }

}
/**
 * CredentialsApi - fetch parameter creator
 * @export
 */
export const CredentialsApiFetchParamCreator = function (configuration?: Configuration) {
    return {
        /**
         * Method create credential definition. The id of the response will be matched when you receive event from the websocket
         * @summary Create credential definition
         * @param {CreateCredentialDefinitionRequsetDto} body
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        attestationControllerCreateCredentialDefinition(body: CreateCredentialDefinitionRequsetDto, options: any = {}): FetchArgs {
            // verify required parameter 'body' is not null or undefined
            if (body === null || body === undefined) {
                throw new RequiredError('body','Required parameter body was null or undefined when calling attestationControllerCreateCredentialDefinition.');
            }
            const localVarPath = `/api/v1/credentials/definition`;
            const localVarUrlObj = url.parse(localVarPath, true);
            const localVarRequestOptions = Object.assign({ method: 'POST' }, options);
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            localVarHeaderParameter['Content-Type'] = 'application/json';

            localVarUrlObj.query = Object.assign({}, localVarUrlObj.query, localVarQueryParameter, options.query);
            // fix override query string Detail: https://stackoverflow.com/a/7517673/1077943
            delete localVarUrlObj.search;
            localVarRequestOptions.headers = Object.assign({}, localVarHeaderParameter, options.headers);
            const needsSerialization = (<any>"CreateCredentialDefinitionRequsetDto" !== "string") || localVarRequestOptions.headers['Content-Type'] === 'application/json';
            localVarRequestOptions.body =  needsSerialization ? JSON.stringify(body || {}) : (body || "");

            return {
                url: url.format(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * Method list credential definition no filters applied. The id of the response will be matched when you receive event from the websocket
         * @summary List all credential
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        attestationControllerCredentials(options: any = {}): FetchArgs {
            const localVarPath = `/api/v1/credentials`;
            const localVarUrlObj = url.parse(localVarPath, true);
            const localVarRequestOptions = Object.assign({ method: 'GET' }, options);
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            localVarUrlObj.query = Object.assign({}, localVarUrlObj.query, localVarQueryParameter, options.query);
            // fix override query string Detail: https://stackoverflow.com/a/7517673/1077943
            delete localVarUrlObj.search;
            localVarRequestOptions.headers = Object.assign({}, localVarHeaderParameter, options.headers);

            return {
                url: url.format(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * Method issue credential, it will create an offer and send it to specified receiver (connectionId). The id of the response will be matched when you receive event from the websocket
         * @summary Issue credential
         * @param {IssueCredentialRequestDto} body
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        attestationControllerIssueCredential(body: IssueCredentialRequestDto, options: any = {}): FetchArgs {
            // verify required parameter 'body' is not null or undefined
            if (body === null || body === undefined) {
                throw new RequiredError('body','Required parameter body was null or undefined when calling attestationControllerIssueCredential.');
            }
            const localVarPath = `/api/v1/credentials/issue`;
            const localVarUrlObj = url.parse(localVarPath, true);
            const localVarRequestOptions = Object.assign({ method: 'POST' }, options);
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            localVarHeaderParameter['Content-Type'] = 'application/json';

            localVarUrlObj.query = Object.assign({}, localVarUrlObj.query, localVarQueryParameter, options.query);
            // fix override query string Detail: https://stackoverflow.com/a/7517673/1077943
            delete localVarUrlObj.search;
            localVarRequestOptions.headers = Object.assign({}, localVarHeaderParameter, options.headers);
            const needsSerialization = (<any>"IssueCredentialRequestDto" !== "string") || localVarRequestOptions.headers['Content-Type'] === 'application/json';
            localVarRequestOptions.body =  needsSerialization ? JSON.stringify(body || {}) : (body || "");

            return {
                url: url.format(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
    }
};

/**
 * CredentialsApi - functional programming interface
 * @export
 */
export const CredentialsApiFp = function(configuration?: Configuration) {
    return {
        /**
         * Method create credential definition. The id of the response will be matched when you receive event from the websocket
         * @summary Create credential definition
         * @param {CreateCredentialDefinitionRequsetDto} body
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        attestationControllerCreateCredentialDefinition(body: CreateCredentialDefinitionRequsetDto, options?: any): (fetch?: FetchAPI, basePath?: string) => Promise<GatewayAcceptedResponseDto> {
            const localVarFetchArgs = CredentialsApiFetchParamCreator(configuration).attestationControllerCreateCredentialDefinition(body, options);
            return (fetch: FetchAPI = isomorphicFetch, basePath: string = BASE_PATH) => {
                return fetch(basePath + localVarFetchArgs.url, localVarFetchArgs.options).then((response) => {
                    if (response.status >= 200 && response.status < 300) {
                        return response.json();
                    } else {
                        throw response;
                    }
                });
            };
        },
        /**
         * Method list credential definition no filters applied. The id of the response will be matched when you receive event from the websocket
         * @summary List all credential
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        attestationControllerCredentials(options?: any): (fetch?: FetchAPI, basePath?: string) => Promise<GatewayAcceptedResponseDto> {
            const localVarFetchArgs = CredentialsApiFetchParamCreator(configuration).attestationControllerCredentials(options);
            return (fetch: FetchAPI = isomorphicFetch, basePath: string = BASE_PATH) => {
                return fetch(basePath + localVarFetchArgs.url, localVarFetchArgs.options).then((response) => {
                    if (response.status >= 200 && response.status < 300) {
                        return response.json();
                    } else {
                        throw response;
                    }
                });
            };
        },
        /**
         * Method issue credential, it will create an offer and send it to specified receiver (connectionId). The id of the response will be matched when you receive event from the websocket
         * @summary Issue credential
         * @param {IssueCredentialRequestDto} body
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        attestationControllerIssueCredential(body: IssueCredentialRequestDto, options?: any): (fetch?: FetchAPI, basePath?: string) => Promise<GatewayAcceptedResponseDto> {
            const localVarFetchArgs = CredentialsApiFetchParamCreator(configuration).attestationControllerIssueCredential(body, options);
            return (fetch: FetchAPI = isomorphicFetch, basePath: string = BASE_PATH) => {
                return fetch(basePath + localVarFetchArgs.url, localVarFetchArgs.options).then((response) => {
                    if (response.status >= 200 && response.status < 300) {
                        return response.json();
                    } else {
                        throw response;
                    }
                });
            };
        },
    }
};

/**
 * CredentialsApi - factory interface
 * @export
 */
export const CredentialsApiFactory = function (configuration?: Configuration, fetch?: FetchAPI, basePath?: string) {
    return {
        /**
         * Method create credential definition. The id of the response will be matched when you receive event from the websocket
         * @summary Create credential definition
         * @param {CreateCredentialDefinitionRequsetDto} body
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        attestationControllerCreateCredentialDefinition(body: CreateCredentialDefinitionRequsetDto, options?: any) {
            return CredentialsApiFp(configuration).attestationControllerCreateCredentialDefinition(body, options)(fetch, basePath);
        },
        /**
         * Method list credential definition no filters applied. The id of the response will be matched when you receive event from the websocket
         * @summary List all credential
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        attestationControllerCredentials(options?: any) {
            return CredentialsApiFp(configuration).attestationControllerCredentials(options)(fetch, basePath);
        },
        /**
         * Method issue credential, it will create an offer and send it to specified receiver (connectionId). The id of the response will be matched when you receive event from the websocket
         * @summary Issue credential
         * @param {IssueCredentialRequestDto} body
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        attestationControllerIssueCredential(body: IssueCredentialRequestDto, options?: any) {
            return CredentialsApiFp(configuration).attestationControllerIssueCredential(body, options)(fetch, basePath);
        },
    };
};

/**
 * CredentialsApi - object-oriented interface
 * @export
 * @class CredentialsApi
 * @extends {BaseAPI}
 */
export class CredentialsApi extends BaseAPI {
    /**
     * Method create credential definition. The id of the response will be matched when you receive event from the websocket
     * @summary Create credential definition
     * @param {CreateCredentialDefinitionRequsetDto} body
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof CredentialsApi
     */
    public attestationControllerCreateCredentialDefinition(body: CreateCredentialDefinitionRequsetDto, options?: any) {
        return CredentialsApiFp(this.configuration).attestationControllerCreateCredentialDefinition(body, options)(this.fetch, this.basePath);
    }

    /**
     * Method list credential definition no filters applied. The id of the response will be matched when you receive event from the websocket
     * @summary List all credential
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof CredentialsApi
     */
    public attestationControllerCredentials(options?: any) {
        return CredentialsApiFp(this.configuration).attestationControllerCredentials(options)(this.fetch, this.basePath);
    }

    /**
     * Method issue credential, it will create an offer and send it to specified receiver (connectionId). The id of the response will be matched when you receive event from the websocket
     * @summary Issue credential
     * @param {IssueCredentialRequestDto} body
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof CredentialsApi
     */
    public attestationControllerIssueCredential(body: IssueCredentialRequestDto, options?: any) {
        return CredentialsApiFp(this.configuration).attestationControllerIssueCredential(body, options)(this.fetch, this.basePath);
    }

}
/**
 * CredentialsOffersApi - fetch parameter creator
 * @export
 */
export const CredentialsOffersApiFetchParamCreator = function (configuration?: Configuration) {
    return {
        /**
         * Method list accept credential offer. The id of the response will be matched when you receive event from the websocket
         * @summary Accept credential offers
         * @param {string} credential_record_id
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        attestationControllerAcceptCredential(credential_record_id: string, options: any = {}): FetchArgs {
            // verify required parameter 'credential_record_id' is not null or undefined
            if (credential_record_id === null || credential_record_id === undefined) {
                throw new RequiredError('credential_record_id','Required parameter credential_record_id was null or undefined when calling attestationControllerAcceptCredential.');
            }
            const localVarPath = `/api/v1/credentials/offers/{credential_record_id}/accept`
                .replace(`{${"credential_record_id"}}`, encodeURIComponent(String(credential_record_id)));
            const localVarUrlObj = url.parse(localVarPath, true);
            const localVarRequestOptions = Object.assign({ method: 'POST' }, options);
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            localVarUrlObj.query = Object.assign({}, localVarUrlObj.query, localVarQueryParameter, options.query);
            // fix override query string Detail: https://stackoverflow.com/a/7517673/1077943
            delete localVarUrlObj.search;
            localVarRequestOptions.headers = Object.assign({}, localVarHeaderParameter, options.headers);

            return {
                url: url.format(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * Method list offers that are received, but not accepted. The id of the response will be matched when you receive event from the websocket
         * @summary List unaccepted credential offers
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        attestationControllerGetCredentialOffers(options: any = {}): FetchArgs {
            const localVarPath = `/api/v1/credentials/offers`;
            const localVarUrlObj = url.parse(localVarPath, true);
            const localVarRequestOptions = Object.assign({ method: 'GET' }, options);
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            localVarUrlObj.query = Object.assign({}, localVarUrlObj.query, localVarQueryParameter, options.query);
            // fix override query string Detail: https://stackoverflow.com/a/7517673/1077943
            delete localVarUrlObj.search;
            localVarRequestOptions.headers = Object.assign({}, localVarHeaderParameter, options.headers);

            return {
                url: url.format(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * Method will send basic message to a connection. The id of the response will be matched when you receive event from the websocket
         * @summary Send basic message
         * @param {MakeBasicMessageRequestDto} body
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        attestationControllerSendMeesage(body: MakeBasicMessageRequestDto, options: any = {}): FetchArgs {
            // verify required parameter 'body' is not null or undefined
            if (body === null || body === undefined) {
                throw new RequiredError('body','Required parameter body was null or undefined when calling attestationControllerSendMeesage.');
            }
            const localVarPath = `/api/v1/messages`;
            const localVarUrlObj = url.parse(localVarPath, true);
            const localVarRequestOptions = Object.assign({ method: 'POST' }, options);
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            localVarHeaderParameter['Content-Type'] = 'application/json';

            localVarUrlObj.query = Object.assign({}, localVarUrlObj.query, localVarQueryParameter, options.query);
            // fix override query string Detail: https://stackoverflow.com/a/7517673/1077943
            delete localVarUrlObj.search;
            localVarRequestOptions.headers = Object.assign({}, localVarHeaderParameter, options.headers);
            const needsSerialization = (<any>"MakeBasicMessageRequestDto" !== "string") || localVarRequestOptions.headers['Content-Type'] === 'application/json';
            localVarRequestOptions.body =  needsSerialization ? JSON.stringify(body || {}) : (body || "");

            return {
                url: url.format(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
    }
};

/**
 * CredentialsOffersApi - functional programming interface
 * @export
 */
export const CredentialsOffersApiFp = function(configuration?: Configuration) {
    return {
        /**
         * Method list accept credential offer. The id of the response will be matched when you receive event from the websocket
         * @summary Accept credential offers
         * @param {string} credential_record_id
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        attestationControllerAcceptCredential(credential_record_id: string, options?: any): (fetch?: FetchAPI, basePath?: string) => Promise<GatewayAcceptedResponseDto> {
            const localVarFetchArgs = CredentialsOffersApiFetchParamCreator(configuration).attestationControllerAcceptCredential(credential_record_id, options);
            return (fetch: FetchAPI = isomorphicFetch, basePath: string = BASE_PATH) => {
                return fetch(basePath + localVarFetchArgs.url, localVarFetchArgs.options).then((response) => {
                    if (response.status >= 200 && response.status < 300) {
                        return response.json();
                    } else {
                        throw response;
                    }
                });
            };
        },
        /**
         * Method list offers that are received, but not accepted. The id of the response will be matched when you receive event from the websocket
         * @summary List unaccepted credential offers
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        attestationControllerGetCredentialOffers(options?: any): (fetch?: FetchAPI, basePath?: string) => Promise<GatewayAcceptedResponseDto> {
            const localVarFetchArgs = CredentialsOffersApiFetchParamCreator(configuration).attestationControllerGetCredentialOffers(options);
            return (fetch: FetchAPI = isomorphicFetch, basePath: string = BASE_PATH) => {
                return fetch(basePath + localVarFetchArgs.url, localVarFetchArgs.options).then((response) => {
                    if (response.status >= 200 && response.status < 300) {
                        return response.json();
                    } else {
                        throw response;
                    }
                });
            };
        },
        /**
         * Method will send basic message to a connection. The id of the response will be matched when you receive event from the websocket
         * @summary Send basic message
         * @param {MakeBasicMessageRequestDto} body
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        attestationControllerSendMeesage(body: MakeBasicMessageRequestDto, options?: any): (fetch?: FetchAPI, basePath?: string) => Promise<GatewayAcceptedResponseDto> {
            const localVarFetchArgs = CredentialsOffersApiFetchParamCreator(configuration).attestationControllerSendMeesage(body, options);
            return (fetch: FetchAPI = isomorphicFetch, basePath: string = BASE_PATH) => {
                return fetch(basePath + localVarFetchArgs.url, localVarFetchArgs.options).then((response) => {
                    if (response.status >= 200 && response.status < 300) {
                        return response.json();
                    } else {
                        throw response;
                    }
                });
            };
        },
    }
};

/**
 * CredentialsOffersApi - factory interface
 * @export
 */
export const CredentialsOffersApiFactory = function (configuration?: Configuration, fetch?: FetchAPI, basePath?: string) {
    return {
        /**
         * Method list accept credential offer. The id of the response will be matched when you receive event from the websocket
         * @summary Accept credential offers
         * @param {string} credential_record_id
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        attestationControllerAcceptCredential(credential_record_id: string, options?: any) {
            return CredentialsOffersApiFp(configuration).attestationControllerAcceptCredential(credential_record_id, options)(fetch, basePath);
        },
        /**
         * Method list offers that are received, but not accepted. The id of the response will be matched when you receive event from the websocket
         * @summary List unaccepted credential offers
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        attestationControllerGetCredentialOffers(options?: any) {
            return CredentialsOffersApiFp(configuration).attestationControllerGetCredentialOffers(options)(fetch, basePath);
        },
        /**
         * Method will send basic message to a connection. The id of the response will be matched when you receive event from the websocket
         * @summary Send basic message
         * @param {MakeBasicMessageRequestDto} body
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        attestationControllerSendMeesage(body: MakeBasicMessageRequestDto, options?: any) {
            return CredentialsOffersApiFp(configuration).attestationControllerSendMeesage(body, options)(fetch, basePath);
        },
    };
};

/**
 * CredentialsOffersApi - object-oriented interface
 * @export
 * @class CredentialsOffersApi
 * @extends {BaseAPI}
 */
export class CredentialsOffersApi extends BaseAPI {
    /**
     * Method list accept credential offer. The id of the response will be matched when you receive event from the websocket
     * @summary Accept credential offers
     * @param {string} credential_record_id
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof CredentialsOffersApi
     */
    public attestationControllerAcceptCredential(credential_record_id: string, options?: any) {
        return CredentialsOffersApiFp(this.configuration).attestationControllerAcceptCredential(credential_record_id, options)(this.fetch, this.basePath);
    }

    /**
     * Method list offers that are received, but not accepted. The id of the response will be matched when you receive event from the websocket
     * @summary List unaccepted credential offers
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof CredentialsOffersApi
     */
    public attestationControllerGetCredentialOffers(options?: any) {
        return CredentialsOffersApiFp(this.configuration).attestationControllerGetCredentialOffers(options)(this.fetch, this.basePath);
    }

    /**
     * Method will send basic message to a connection. The id of the response will be matched when you receive event from the websocket
     * @summary Send basic message
     * @param {MakeBasicMessageRequestDto} body
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof CredentialsOffersApi
     */
    public attestationControllerSendMeesage(body: MakeBasicMessageRequestDto, options?: any) {
        return CredentialsOffersApiFp(this.configuration).attestationControllerSendMeesage(body, options)(this.fetch, this.basePath);
    }

}
/**
 * CredentialsProofApi - fetch parameter creator
 * @export
 */
export const CredentialsProofApiFetchParamCreator = function (configuration?: Configuration) {
    return {
        /**
         * Method accept credential proof. The id of the response will be matched when you receive event from the websocket
         * @summary Accept credential proof
         * @param {string} proof_record_id
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        proofControllerAcceptProof(proof_record_id: string, options: any = {}): FetchArgs {
            // verify required parameter 'proof_record_id' is not null or undefined
            if (proof_record_id === null || proof_record_id === undefined) {
                throw new RequiredError('proof_record_id','Required parameter proof_record_id was null or undefined when calling proofControllerAcceptProof.');
            }
            const localVarPath = `/api/v1/credentials/proof/{proof_record_id}/accept`
                .replace(`{${"proof_record_id"}}`, encodeURIComponent(String(proof_record_id)));
            const localVarUrlObj = url.parse(localVarPath, true);
            const localVarRequestOptions = Object.assign({ method: 'POST' }, options);
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            localVarUrlObj.query = Object.assign({}, localVarUrlObj.query, localVarQueryParameter, options.query);
            // fix override query string Detail: https://stackoverflow.com/a/7517673/1077943
            delete localVarUrlObj.search;
            localVarRequestOptions.headers = Object.assign({}, localVarHeaderParameter, options.headers);

            return {
                url: url.format(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * Method will issue proof. If connection id is not passed, the proof will be OOB. The id of the response will be matched when you receive event from the websocket
         * @summary Issue proof for credential
         * @param {IssueProofRequestDto} body
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        proofControllerIssueProof(body: IssueProofRequestDto, options: any = {}): FetchArgs {
            // verify required parameter 'body' is not null or undefined
            if (body === null || body === undefined) {
                throw new RequiredError('body','Required parameter body was null or undefined when calling proofControllerIssueProof.');
            }
            const localVarPath = `/api/v1/credentials/proof/issue`;
            const localVarUrlObj = url.parse(localVarPath, true);
            const localVarRequestOptions = Object.assign({ method: 'POST' }, options);
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            localVarHeaderParameter['Content-Type'] = 'application/json';

            localVarUrlObj.query = Object.assign({}, localVarUrlObj.query, localVarQueryParameter, options.query);
            // fix override query string Detail: https://stackoverflow.com/a/7517673/1077943
            delete localVarUrlObj.search;
            localVarRequestOptions.headers = Object.assign({}, localVarHeaderParameter, options.headers);
            const needsSerialization = (<any>"IssueProofRequestDto" !== "string") || localVarRequestOptions.headers['Content-Type'] === 'application/json';
            localVarRequestOptions.body =  needsSerialization ? JSON.stringify(body || {}) : (body || "");

            return {
                url: url.format(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * Method list all received unaccepted proofs. Status - request-receive. The id of the response will be matched when you receive event from the websocket
         * @summary List received unaccepted proofs
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        proofControllerProofs(options: any = {}): FetchArgs {
            const localVarPath = `/api/v1/credentials/proof`;
            const localVarUrlObj = url.parse(localVarPath, true);
            const localVarRequestOptions = Object.assign({ method: 'GET' }, options);
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            localVarUrlObj.query = Object.assign({}, localVarUrlObj.query, localVarQueryParameter, options.query);
            // fix override query string Detail: https://stackoverflow.com/a/7517673/1077943
            delete localVarUrlObj.search;
            localVarRequestOptions.headers = Object.assign({}, localVarHeaderParameter, options.headers);

            return {
                url: url.format(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
    }
};

/**
 * CredentialsProofApi - functional programming interface
 * @export
 */
export const CredentialsProofApiFp = function(configuration?: Configuration) {
    return {
        /**
         * Method accept credential proof. The id of the response will be matched when you receive event from the websocket
         * @summary Accept credential proof
         * @param {string} proof_record_id
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        proofControllerAcceptProof(proof_record_id: string, options?: any): (fetch?: FetchAPI, basePath?: string) => Promise<GatewayAcceptedResponseDto> {
            const localVarFetchArgs = CredentialsProofApiFetchParamCreator(configuration).proofControllerAcceptProof(proof_record_id, options);
            return (fetch: FetchAPI = isomorphicFetch, basePath: string = BASE_PATH) => {
                return fetch(basePath + localVarFetchArgs.url, localVarFetchArgs.options).then((response) => {
                    if (response.status >= 200 && response.status < 300) {
                        return response.json();
                    } else {
                        throw response;
                    }
                });
            };
        },
        /**
         * Method will issue proof. If connection id is not passed, the proof will be OOB. The id of the response will be matched when you receive event from the websocket
         * @summary Issue proof for credential
         * @param {IssueProofRequestDto} body
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        proofControllerIssueProof(body: IssueProofRequestDto, options?: any): (fetch?: FetchAPI, basePath?: string) => Promise<GatewayAcceptedResponseDto> {
            const localVarFetchArgs = CredentialsProofApiFetchParamCreator(configuration).proofControllerIssueProof(body, options);
            return (fetch: FetchAPI = isomorphicFetch, basePath: string = BASE_PATH) => {
                return fetch(basePath + localVarFetchArgs.url, localVarFetchArgs.options).then((response) => {
                    if (response.status >= 200 && response.status < 300) {
                        return response.json();
                    } else {
                        throw response;
                    }
                });
            };
        },
        /**
         * Method list all received unaccepted proofs. Status - request-receive. The id of the response will be matched when you receive event from the websocket
         * @summary List received unaccepted proofs
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        proofControllerProofs(options?: any): (fetch?: FetchAPI, basePath?: string) => Promise<GatewayAcceptedResponseDto> {
            const localVarFetchArgs = CredentialsProofApiFetchParamCreator(configuration).proofControllerProofs(options);
            return (fetch: FetchAPI = isomorphicFetch, basePath: string = BASE_PATH) => {
                return fetch(basePath + localVarFetchArgs.url, localVarFetchArgs.options).then((response) => {
                    if (response.status >= 200 && response.status < 300) {
                        return response.json();
                    } else {
                        throw response;
                    }
                });
            };
        },
    }
};

/**
 * CredentialsProofApi - factory interface
 * @export
 */
export const CredentialsProofApiFactory = function (configuration?: Configuration, fetch?: FetchAPI, basePath?: string) {
    return {
        /**
         * Method accept credential proof. The id of the response will be matched when you receive event from the websocket
         * @summary Accept credential proof
         * @param {string} proof_record_id
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        proofControllerAcceptProof(proof_record_id: string, options?: any) {
            return CredentialsProofApiFp(configuration).proofControllerAcceptProof(proof_record_id, options)(fetch, basePath);
        },
        /**
         * Method will issue proof. If connection id is not passed, the proof will be OOB. The id of the response will be matched when you receive event from the websocket
         * @summary Issue proof for credential
         * @param {IssueProofRequestDto} body
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        proofControllerIssueProof(body: IssueProofRequestDto, options?: any) {
            return CredentialsProofApiFp(configuration).proofControllerIssueProof(body, options)(fetch, basePath);
        },
        /**
         * Method list all received unaccepted proofs. Status - request-receive. The id of the response will be matched when you receive event from the websocket
         * @summary List received unaccepted proofs
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        proofControllerProofs(options?: any) {
            return CredentialsProofApiFp(configuration).proofControllerProofs(options)(fetch, basePath);
        },
    };
};

/**
 * CredentialsProofApi - object-oriented interface
 * @export
 * @class CredentialsProofApi
 * @extends {BaseAPI}
 */
export class CredentialsProofApi extends BaseAPI {
    /**
     * Method accept credential proof. The id of the response will be matched when you receive event from the websocket
     * @summary Accept credential proof
     * @param {string} proof_record_id
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof CredentialsProofApi
     */
    public proofControllerAcceptProof(proof_record_id: string, options?: any) {
        return CredentialsProofApiFp(this.configuration).proofControllerAcceptProof(proof_record_id, options)(this.fetch, this.basePath);
    }

    /**
     * Method will issue proof. If connection id is not passed, the proof will be OOB. The id of the response will be matched when you receive event from the websocket
     * @summary Issue proof for credential
     * @param {IssueProofRequestDto} body
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof CredentialsProofApi
     */
    public proofControllerIssueProof(body: IssueProofRequestDto, options?: any) {
        return CredentialsProofApiFp(this.configuration).proofControllerIssueProof(body, options)(this.fetch, this.basePath);
    }

    /**
     * Method list all received unaccepted proofs. Status - request-receive. The id of the response will be matched when you receive event from the websocket
     * @summary List received unaccepted proofs
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof CredentialsProofApi
     */
    public proofControllerProofs(options?: any) {
        return CredentialsProofApiFp(this.configuration).proofControllerProofs(options)(this.fetch, this.basePath);
    }

}
/**
 * SchemaApi - fetch parameter creator
 * @export
 */
export const SchemaApiFetchParamCreator = function (configuration?: Configuration) {
    return {
        /**
         * Method will create schema. The id of the response will be matched when you receive event from the websocket
         * @summary Create schema
         * @param {CreateSchemaRequestDto} body
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        attestationControllerCreateSchema(body: CreateSchemaRequestDto, options: any = {}): FetchArgs {
            // verify required parameter 'body' is not null or undefined
            if (body === null || body === undefined) {
                throw new RequiredError('body','Required parameter body was null or undefined when calling attestationControllerCreateSchema.');
            }
            const localVarPath = `/api/v1/schemas`;
            const localVarUrlObj = url.parse(localVarPath, true);
            const localVarRequestOptions = Object.assign({ method: 'POST' }, options);
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            localVarHeaderParameter['Content-Type'] = 'application/json';

            localVarUrlObj.query = Object.assign({}, localVarUrlObj.query, localVarQueryParameter, options.query);
            // fix override query string Detail: https://stackoverflow.com/a/7517673/1077943
            delete localVarUrlObj.search;
            localVarRequestOptions.headers = Object.assign({}, localVarHeaderParameter, options.headers);
            const needsSerialization = (<any>"CreateSchemaRequestDto" !== "string") || localVarRequestOptions.headers['Content-Type'] === 'application/json';
            localVarRequestOptions.body =  needsSerialization ? JSON.stringify(body || {}) : (body || "");

            return {
                url: url.format(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * Method will fetch specific schema or return null. The id of the response will be matched when you receive event from the websocket
         * @summary Get schema by id
         * @param {GetSchemaRequestDto} body
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        attestationControllerGetSchemaById(body: GetSchemaRequestDto, options: any = {}): FetchArgs {
            // verify required parameter 'body' is not null or undefined
            if (body === null || body === undefined) {
                throw new RequiredError('body','Required parameter body was null or undefined when calling attestationControllerGetSchemaById.');
            }
            const localVarPath = `/api/v1/schemas-by-id`;
            const localVarUrlObj = url.parse(localVarPath, true);
            const localVarRequestOptions = Object.assign({ method: 'POST' }, options);
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            localVarHeaderParameter['Content-Type'] = 'application/json';

            localVarUrlObj.query = Object.assign({}, localVarUrlObj.query, localVarQueryParameter, options.query);
            // fix override query string Detail: https://stackoverflow.com/a/7517673/1077943
            delete localVarUrlObj.search;
            localVarRequestOptions.headers = Object.assign({}, localVarHeaderParameter, options.headers);
            const needsSerialization = (<any>"GetSchemaRequestDto" !== "string") || localVarRequestOptions.headers['Content-Type'] === 'application/json';
            localVarRequestOptions.body =  needsSerialization ? JSON.stringify(body || {}) : (body || "");

            return {
                url: url.format(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * Method will fetch all schemas. The id of the response will be matched when you receive event from the websocket
         * @summary List all schemas
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        attestationControllerListSchema(options: any = {}): FetchArgs {
            const localVarPath = `/api/v1/schemas`;
            const localVarUrlObj = url.parse(localVarPath, true);
            const localVarRequestOptions = Object.assign({ method: 'GET' }, options);
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            localVarUrlObj.query = Object.assign({}, localVarUrlObj.query, localVarQueryParameter, options.query);
            // fix override query string Detail: https://stackoverflow.com/a/7517673/1077943
            delete localVarUrlObj.search;
            localVarRequestOptions.headers = Object.assign({}, localVarHeaderParameter, options.headers);

            return {
                url: url.format(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
    }
};

/**
 * SchemaApi - functional programming interface
 * @export
 */
export const SchemaApiFp = function(configuration?: Configuration) {
    return {
        /**
         * Method will create schema. The id of the response will be matched when you receive event from the websocket
         * @summary Create schema
         * @param {CreateSchemaRequestDto} body
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        attestationControllerCreateSchema(body: CreateSchemaRequestDto, options?: any): (fetch?: FetchAPI, basePath?: string) => Promise<GatewayAcceptedResponseDto> {
            const localVarFetchArgs = SchemaApiFetchParamCreator(configuration).attestationControllerCreateSchema(body, options);
            return (fetch: FetchAPI = isomorphicFetch, basePath: string = BASE_PATH) => {
                return fetch(basePath + localVarFetchArgs.url, localVarFetchArgs.options).then((response) => {
                    if (response.status >= 200 && response.status < 300) {
                        return response.json();
                    } else {
                        throw response;
                    }
                });
            };
        },
        /**
         * Method will fetch specific schema or return null. The id of the response will be matched when you receive event from the websocket
         * @summary Get schema by id
         * @param {GetSchemaRequestDto} body
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        attestationControllerGetSchemaById(body: GetSchemaRequestDto, options?: any): (fetch?: FetchAPI, basePath?: string) => Promise<GatewayAcceptedResponseDto> {
            const localVarFetchArgs = SchemaApiFetchParamCreator(configuration).attestationControllerGetSchemaById(body, options);
            return (fetch: FetchAPI = isomorphicFetch, basePath: string = BASE_PATH) => {
                return fetch(basePath + localVarFetchArgs.url, localVarFetchArgs.options).then((response) => {
                    if (response.status >= 200 && response.status < 300) {
                        return response.json();
                    } else {
                        throw response;
                    }
                });
            };
        },
        /**
         * Method will fetch all schemas. The id of the response will be matched when you receive event from the websocket
         * @summary List all schemas
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        attestationControllerListSchema(options?: any): (fetch?: FetchAPI, basePath?: string) => Promise<GatewayAcceptedResponseDto> {
            const localVarFetchArgs = SchemaApiFetchParamCreator(configuration).attestationControllerListSchema(options);
            return (fetch: FetchAPI = isomorphicFetch, basePath: string = BASE_PATH) => {
                return fetch(basePath + localVarFetchArgs.url, localVarFetchArgs.options).then((response) => {
                    if (response.status >= 200 && response.status < 300) {
                        return response.json();
                    } else {
                        throw response;
                    }
                });
            };
        },
    }
};

/**
 * SchemaApi - factory interface
 * @export
 */
export const SchemaApiFactory = function (configuration?: Configuration, fetch?: FetchAPI, basePath?: string) {
    return {
        /**
         * Method will create schema. The id of the response will be matched when you receive event from the websocket
         * @summary Create schema
         * @param {CreateSchemaRequestDto} body
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        attestationControllerCreateSchema(body: CreateSchemaRequestDto, options?: any) {
            return SchemaApiFp(configuration).attestationControllerCreateSchema(body, options)(fetch, basePath);
        },
        /**
         * Method will fetch specific schema or return null. The id of the response will be matched when you receive event from the websocket
         * @summary Get schema by id
         * @param {GetSchemaRequestDto} body
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        attestationControllerGetSchemaById(body: GetSchemaRequestDto, options?: any) {
            return SchemaApiFp(configuration).attestationControllerGetSchemaById(body, options)(fetch, basePath);
        },
        /**
         * Method will fetch all schemas. The id of the response will be matched when you receive event from the websocket
         * @summary List all schemas
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        attestationControllerListSchema(options?: any) {
            return SchemaApiFp(configuration).attestationControllerListSchema(options)(fetch, basePath);
        },
    };
};

/**
 * SchemaApi - object-oriented interface
 * @export
 * @class SchemaApi
 * @extends {BaseAPI}
 */
export class SchemaApi extends BaseAPI {
    /**
     * Method will create schema. The id of the response will be matched when you receive event from the websocket
     * @summary Create schema
     * @param {CreateSchemaRequestDto} body
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof SchemaApi
     */
    public attestationControllerCreateSchema(body: CreateSchemaRequestDto, options?: any) {
        return SchemaApiFp(this.configuration).attestationControllerCreateSchema(body, options)(this.fetch, this.basePath);
    }

    /**
     * Method will fetch specific schema or return null. The id of the response will be matched when you receive event from the websocket
     * @summary Get schema by id
     * @param {GetSchemaRequestDto} body
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof SchemaApi
     */
    public attestationControllerGetSchemaById(body: GetSchemaRequestDto, options?: any) {
        return SchemaApiFp(this.configuration).attestationControllerGetSchemaById(body, options)(this.fetch, this.basePath);
    }

    /**
     * Method will fetch all schemas. The id of the response will be matched when you receive event from the websocket
     * @summary List all schemas
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof SchemaApi
     */
    public attestationControllerListSchema(options?: any) {
        return SchemaApiFp(this.configuration).attestationControllerListSchema(options)(this.fetch, this.basePath);
    }

}
