import React from "react";
import { observer } from "mobx-react";
import {Button, Popover} from "antd";
import s from './styles.module.scss';

interface ConnectionItemProps {
  item: any;
  onClick?: () => void;
  onOpen?: () => void;
  onRemove?: () => void;
}

const ConnectionItem = observer(({ item, onOpen, onRemove }: ConnectionItemProps) => {
  const ppContent = (
    <pre>
      {JSON.stringify(item, null, 2)}
    </pre>
  );
  return (
    <div className={s.item}>
      <Popover trigger={["click"]} content={ppContent}>
        <div>
          ConnectionId: <b>{item.id}</b> State: <b>{item.state}</b> Role: <b>{item.role}</b>
          Their Label: <b>{item.theirLabel}</b>
        </div>
      </Popover>
      <div>
        {onOpen && <Button onClick={onOpen}>Go to connection</Button>}
        {onRemove && <Button onClick={onRemove}>Remove</Button>}
      </div>
    </div>
  );
});

export default ConnectionItem;

