import React from "react";
import { observer } from "mobx-react";
import s from './styles.module.scss';
import {Button} from "antd";

interface CredentialItemProps {
  item: any;
  onOpen?: () => void;
  onRemove?: () => void;
}

const CredentialItem = observer(({ item, onOpen, onRemove }: CredentialItemProps) => {
  return (
    <div className={s.item}>
      <pre>
        {JSON.stringify(item, null, 2)}
      </pre>
      <div>
        {onOpen && <Button onClick={onOpen}>Go to credential</Button>}
        {onRemove && <Button onClick={onRemove}>Remove</Button>}
      </div>
    </div>
  );
});

export default CredentialItem;

