import React from "react";
import { observer } from "mobx-react";
import {Button} from "antd";
import s from './styles.module.scss';

interface SchemaItemProps {
  item: any;
  onClick?: () => void;
}

const SchemaItem = observer(({ item, onClick }: SchemaItemProps) => {
  const query = encodeURIComponent(item.id);
  return (
    <div className={s.item} onClick={onClick}>
      <a href={`http://test.bcovrin.vonx.io/browse/domain?page=1&query=${query}&txn_type=`} target="_blank">
        <Button>
          See {item.id} on ledger
        </Button>
      </a>
      <b>schemaId: {item.schemaId}</b>
      <pre>
        {JSON.stringify(item, null, 2)}
      </pre>
    </div>
  );
});

export default SchemaItem;

