import React from 'react';
import ReactDOM from 'react-dom/client';
import { ConfigProvider, theme } from "antd";
import { BrowserRouter } from "react-router-dom";

import "react-toastify/dist/ReactToastify.css";
import './index.module.scss';
import "@fontsource/roboto";
import "@fontsource/roboto/500.css";
import "@fontsource/roboto/700.css";

import App from './components/App';
import api from "./api";

// @ts-ignore
window.api = api;

const { defaultAlgorithm, compactAlgorithm } = theme;

const root = ReactDOM.createRoot(
  document.getElementById('root') as HTMLElement
);
root.render(
  <BrowserRouter>
    <ConfigProvider
      theme={{
        token: {
          fontFamily: "Roboto",
          fontSize: 14,
        },
        algorithm: [defaultAlgorithm, compactAlgorithm],
      }}
    >
      <App />
    </ConfigProvider>
  </BrowserRouter>
);
