import {makeAutoObservable} from "mobx";
import api from "../../../api";
import {toast} from "react-toastify";

class ConnectionCreatePageStore {
  public loading = false;
  public invitationUrl: string | null = null;
  public oob: string | null = null;

  constructor() {
    makeAutoObservable(this);
  }

  public async createConnection() {
    this.loading = true;
    try {
      const { invitationUrl } = await api.connections.connectionControllerCreateInvitation() as any;
      this.invitationUrl = invitationUrl;
      try {
        this.oob = JSON.stringify(JSON.parse(atob(invitationUrl.split('oob=')[1])), null, 2);
      } catch (e: any) {}
    } catch (e: any) {
      toast(e.message);
    }

    this.loading = false;
  }
}

export type { ConnectionCreatePageStore };

export default ConnectionCreatePageStore;
