import React, {useEffect, useState} from "react";
import { observer } from "mobx-react";
import { Spin } from 'antd';
import QRCode from "react-qr-code";
import ConnectionCreatePageStore from './ConnectionCreatePageStore';
import s from './styles.module.scss';

const ConnectionCreatePage = observer(() => {
  const [store] = useState(() => new ConnectionCreatePageStore());

  useEffect(() => {
    store.createConnection();
  }, [])
  return (
    <div>
      <h2>New Connection invitation</h2>
      <div>
        {store.loading && (
          <Spin />
        )}
        {!store.loading && (
          <>
            <div className={s.info}>
              <div>
                <div>
                  <div className={s.label}>
                    Invitation:
                  </div>
                  <div className={s.url}>
                    <b>
                      {store.invitationUrl}
                    </b>
                  </div>
                  {store.invitationUrl && (
                    <div style={{ background: 'white', padding: '16px' }}>
                      <QRCode value={store.invitationUrl} />
                    </div>
                  )}
                  <br />
                  {store.oob && (
                    <div>
                      Invitation:
                      <pre>
                        {store.oob}
                      </pre>
                    </div>
                  )}
                </div>
              </div>
            </div>
          </>
        )}
      </div>
    </div>
  );
});

export default ConnectionCreatePage;
