import {makeAutoObservable, runInAction} from "mobx";
import api from "../../../api";
import {toast} from "react-toastify";

class ConnectionViewPageStore {
  public loading = false;
  public connection: any | null = null;
  constructor() {
    makeAutoObservable(this);
  }

  public async load(id: string) {
    runInAction(() => this.loading = true);
    try {
      const record = await api.connections.connectionControllerGetById(id);
      this.connection = record;
      runInAction(() => {
        this.loading = false;
      });
    } catch (e: any) {
      toast(e.message);
      console.error(e);
      runInAction(() => this.loading = false);
    }
  }
}

export type { ConnectionViewPageStore };

export default ConnectionViewPageStore;
