import React, {useEffect, useState} from "react";
import { observer } from "mobx-react";
import {useNavigate, useParams} from "react-router-dom";
import ConnectionViewPageStore from './ConnectionViewPageStore';
import ConnectionItem from "../../../components/ConnectionItem";
import {Button, Spin} from "antd";
import config from "../../config";
// import MessagesDialog from "./MessagesDialog";
// import OfferCredentialDialog from "./OfferCredentialDialog";

const ConnectionViewPage = observer(() => {
  const { id } = useParams() as any;
  const [store] = useState(() => new ConnectionViewPageStore());
  const [messagingOpen, setMessagingOpen] = useState(false);
  const [offerCredOpen, setOfferCredOpen] = useState(false);
  const navigate = useNavigate();

  useEffect(() => {
    store.load(id);
  }, [id])
  return (
    <div>
      <h2>
        Connection
      </h2>
      {store.loading && (
        <Spin />
      )}
      {!store.loading && (
        <>
          {store.connection && (
            <div>
              <ConnectionItem item={store.connection} />
            </div>
          )}
        </>
      )}
      <h2>
        Actions
      </h2>
      <div>
        {/*<Button onClick={() => setOfferCredOpen(true)}>*/}
        {/*  Offer credential*/}
        {/*</Button>*/}

        {/*<Button onClick={() => setMessagingOpen(true)}>*/}
        {/*  Start messaging*/}
        {/*</Button>*/}
      </div>
      {/*{offerCredOpen && (<OfferCredentialDialog connectionId={id} onClose={() => { setOfferCredOpen(false); }} />)}*/}
      {/*{messagingOpen && (<MessagesDialog connectionId={id} onClose={() => { setMessagingOpen(false); }} />)}*/}
    </div>
  );
});

export default ConnectionViewPage;
