import React, { useState} from "react";
import { observer } from "mobx-react";
import {Button} from 'antd';
import NewCredentialDefDialog from "./NewCredentialDefDialog";

const ConnectionListPage = observer(() => {
  const [newCredDefDialog, setNewCredDefDialog] = useState(false);
  const [newCredDef, setNewCredDef] = useState('');

  return (
    <div>
      <h2>
        Actions
      </h2>
      <div>
        <Button onClick={() => setNewCredDefDialog(true)}>
          Create new credential definition
        </Button>
      </div>
      {newCredDef && (
        <div>
          New credential definition:
          <pre>
            {newCredDef}
          </pre>
        </div>
      )}
      <h2>Credential definition List</h2>
      <div>
        Not available
      </div>
      {newCredDefDialog && (
        <NewCredentialDefDialog
          onCredDefCreated={(credDef) => {
            setNewCredDefDialog(false)
            try {
              setNewCredDef(JSON.stringify(credDef, null, 2))
            } catch (e: any){}
          }}
          onClose={() => setNewCredDefDialog(false)}
        />
      )}
    </div>
  );
});

export default ConnectionListPage;

