import {makeAutoObservable, runInAction} from "mobx";
import api from "../../../api";
import {toast} from "react-toastify";


class CredentialListPageStore {
  public loading = false;
  public items: any[] = [];
  constructor() {
    makeAutoObservable(this);
  }

  public async loadAll() {
    runInAction(() => this.loading = true);
    try {
      const items = await api.credentials.attestationControllerCredentials() as any;
      runInAction(() => {
        this.items = items;
        this.loading = false;
      });
    } catch (e: any) {
      toast(e.message);
      console.error(e);
      runInAction(() => this.loading = false);
    }
  }
}

export type { CredentialListPageStore };

export default CredentialListPageStore;
