import React, {useEffect, useState} from "react";
import {observer} from "mobx-react";
import {Button, Spin} from 'antd';
import CredentialItem from "../../../components/CredentialItem";
import CredentialListPageStore from './CredentialListPageStore';

const CredentialListPage = observer(() => {
  const [store] = useState(() => new CredentialListPageStore());

  useEffect(() => {
    store.loadAll()
  }, [])
  return (
    <div>
      <h2>Credential List</h2>
      <div>
        {store.items.map(p => (
          <CredentialItem
            key={p.referent}
            item={p}
          />
        ))}
        {!store.loading && !store.items.length && (
          <div>
            No items
          </div>
        )}
        {store.loading && (
          <Spin />
        )}
      </div>
    </div>
  );
});

export default CredentialListPage;
