import {makeAutoObservable, runInAction} from "mobx";
import api from "../../../api";
import {toast} from "react-toastify";

class SchemaListPageStore {
  public loading = false;
  public list: any[] = [];
  constructor() {
    makeAutoObservable(this);
  }

  public async loadAll() {
    runInAction(() => this.loading = true);
    try {
      const schemas = await api.schema.attestationControllerListSchema() as any;
      runInAction(() => {
        this.list = schemas
        this.loading = false;
      });
    } catch (e: any) {
      toast(e.message);
      console.error(e);
      runInAction(() => this.loading = false);
    }
  }
}

export type { SchemaListPageStore };

export default SchemaListPageStore;
