import React, {useEffect, useState} from "react";
import { observer } from "mobx-react";
import {Button, Spin} from 'antd';
import SchemaListPageStore from './SchemaListPageStore';
import SchemaItem from "../../../components/SchemaItem";
import NewSchemaDialog from "./NewSchemaDialog";
import s from './styles.module.scss';

const ConnectionListPage = observer(() => {
  const [store] = useState(() => new SchemaListPageStore());
  const [newSchemaDialog, setNewSchemaDialog] = useState(false);

  useEffect(() => {
    store.loadAll()
  }, [])
  return (
    <div>
      <h2>
        Actions
      </h2>
      <div>
        <Button onClick={() => setNewSchemaDialog(true)}>
          Create new schema
        </Button>
      </div>
      <h2>Schema List</h2>
      <div>
        {store.list.map(p => (
          <SchemaItem key={p.id} item={p} />
        ))}
        {store.loading && (
          <Spin />
        )}
      </div>
      {newSchemaDialog && (
        <NewSchemaDialog
          onSchemaCreated={() => {
            store.loadAll();
            setNewSchemaDialog(false)
          }}
          onClose={() => setNewSchemaDialog(false)}
        />
      )}
    </div>
  );
});

export default ConnectionListPage;
